diff --git a/lib/app/data/models/pengaduan_model.dart b/lib/app/data/models/pengaduan_model.dart
index c042905..1c3501a 100644
--- a/lib/app/data/models/pengaduan_model.dart
+++ b/lib/app/data/models/pengaduan_model.dart
@@ -111,4 +111,9 @@ class PengaduanModel {
     if (jumlah == null) return 'Tidak diketahui';
     return '$jumlah $satuan';
   }
+
+  // Getter untuk memeriksa apakah bantuan berupa uang
+  bool get isUang {
+    return stokBantuan?['is_uang'] == true;
+  }
 }
diff --git a/lib/app/data/providers/auth_provider.dart b/lib/app/data/providers/auth_provider.dart
index 0207fa8..235898e 100644
--- a/lib/app/data/providers/auth_provider.dart
+++ b/lib/app/data/providers/auth_provider.dart
@@ -177,14 +177,13 @@ class AuthProvider {
     String? jenis,
   }) async {
     try {
-      // Step 1: Daftarkan user dengan role_id 3 (donatur)
+      print('DEBUG: Memulai proses registrasi donatur dengan email: $email');
+
+      // Step 1: Daftarkan user tanpa metadata dulu
+      // Karena mungkin ada masalah dengan kolom role_id custom
       final response = await _supabaseService.client.auth.signUp(
         email: email,
         password: password,
-        data: {
-          'role_id': 3, // Otomatis set sebagai donatur
-        },
-        // Tidak menggunakan email redirect karena kita akan auto-confirm
       );
 
       final user = response.user;
@@ -192,59 +191,63 @@ class AuthProvider {
         throw Exception('Gagal membuat akun donatur');
       }
 
-      print('User berhasil terdaftar dengan ID: ${user.id}');
+      print('DEBUG: User berhasil terdaftar dengan ID: ${user.id}');
 
-      // Step 2: Buat data donatur di tabel donatur
-      await _supabaseService.client.from('donatur').insert({
-        'id': user.id,
-        'nama_lengkap': namaLengkap,
-        'alamat': alamat,
-        'no_hp': noHp,
-        'email': email,
-        'jenis': jenis ?? 'Individu',
-        'created_at': DateTime.now().toIso8601String(),
-      });
-
-      // Step 3: Pastikan di tabel profiles_backup juga ada data ini (jika digunakan)
       try {
-        await _supabaseService.client.from('profiles_backup').insert({
+        // Step 2: Buat data donatur di tabel donatur
+        print('DEBUG: Mencoba menyimpan data donatur ke tabel donatur');
+
+        final currentTime = DateTime.now().toIso8601String();
+
+        // Data untuk tabel donatur
+        final donaturData = {
           'id': user.id,
-          'updated_at': DateTime.now().toIso8601String(),
-          'role_id': 3,
-        });
+          'nama_lengkap': namaLengkap,
+          'alamat': alamat,
+          'no_hp': noHp,
+          'email': email,
+          'jenis': jenis ?? 'Individu',
+          'created_at': currentTime,
+          'updated_at': currentTime,
+        };
+
+        // Insert ke tabel donatur
+        print('DEBUG: Inserting data to donatur table');
+        await _supabaseService.client.from('donatur').insert(donaturData);
+        print('DEBUG: Berhasil menyimpan data donatur');
+
+        // Step 3: Coba update role_id user menggunakan service yang lebih aman
+        print('DEBUG: Mencoba mengupdate role_id user');
+        await _supabaseService.updateUserRole(user.id, 3);
       } catch (e) {
-        print('Error menyimpan di profiles_backup: $e');
-        // Lanjutkan proses meskipun ada error di step ini
+        print('ERROR: Gagal menyimpan data donatur: $e');
+        throw Exception('Gagal menyimpan data donatur. Silakan coba lagi.');
       }
 
-      print('Berhasil mendaftarkan donatur: $namaLengkap');
-
-      // Pesan untuk pengembang
       print(
-          'CATATAN: User akan perlu login manual. Jika email konfirmasi masih diperlukan,');
-      print(
-          'nonaktifkan verifikasi email di dashboard Supabase: Authentication > Email Templates > Disable Email Confirmation');
+          'DEBUG: Berhasil mendaftarkan donatur: $namaLengkap dengan ID: ${user.id}');
     } catch (e) {
-      print('Error pada signUpDonatur: $e');
+      print('ERROR: Error pada signUpDonatur: $e');
 
       if (e.toString().contains('User already registered')) {
         throw Exception(
             'Email sudah terdaftar. Silakan gunakan email lain atau login dengan email tersebut.');
+      } else if (e.toString().contains('Database error saving new user')) {
+        throw Exception(
+            'Terjadi kesalahan saat menyimpan data pengguna. Silakan coba lagi atau hubungi administrator.');
+      } else if (e.toString().contains('Error sending confirmation mail')) {
+        print('===== PERHATIAN PENGEMBANG =====');
+        print(
+            'Error ini terjadi karena Supabase gagal mengirim email konfirmasi.');
+        print(
+            'Untuk mengatasi ini, nonaktifkan konfirmasi email di dashboard Supabase:');
+        print(
+            '1. Buka project Supabase > Authentication > Email Templates > Confirmation');
+        print('2. Matikan toggle "Enable email confirmations"');
+        print('==============================');
+        throw Exception(
+            'Gagal mengirim email konfirmasi. Mohon hubungi administrator.');
       } else {
-        // Untuk error konfirmasi email, berikan instruksi yang jelas
-        if (e.toString().contains('Error sending confirmation mail')) {
-          print('===== PERHATIAN PENGEMBANG =====');
-          print(
-              'Error ini terjadi karena Supabase gagal mengirim email konfirmasi.');
-          print(
-              'Untuk mengatasi ini, nonaktifkan konfirmasi email di dashboard Supabase:');
-          print(
-              '1. Buka project Supabase > Authentication > Email Templates > Confirmation');
-          print('2. Matikan toggle "Enable email confirmations"');
-          print('==============================');
-          throw Exception(
-              'Gagal mengirim email konfirmasi. Mohon hubungi administrator.');
-        }
         rethrow;
       }
     }
diff --git a/lib/app/modules/auth/controllers/auth_controller.dart b/lib/app/modules/auth/controllers/auth_controller.dart
index f6a82ef..1830fe9 100644
--- a/lib/app/modules/auth/controllers/auth_controller.dart
+++ b/lib/app/modules/auth/controllers/auth_controller.dart
@@ -537,62 +537,114 @@ class AuthController extends GetxController {
     }
 
     isLoading.value = true;
-    try {
-      // Proses registrasi donatur dengan role_id 3
-      await _authProvider.signUpDonatur(
-        email: emailController.text,
-        password: passwordController.text,
-        namaLengkap: namaController.text,
-        alamat: alamatController.text,
-        noHp: noHpController.text,
-        jenis: jenisController.text.isEmpty ? 'Individu' : jenisController.text,
-      );
 
-      Get.snackbar(
-        'Sukses',
-        'Registrasi donatur berhasil! Silakan login dengan akun Anda.',
-        snackPosition: SnackPosition.TOP,
-        backgroundColor: Colors.green,
-        colorText: Colors.white,
-        duration: const Duration(seconds: 5),
-      );
+    // Kita akan mencoba maksimal 2 kali jika terjadi error
+    int maxAttempts = 2;
+    int attempt = 0;
+    bool success = false;
+    Exception? lastError;
 
-      // Bersihkan form
-      clearDonaturRegistrationForm();
+    while (attempt < maxAttempts && !success) {
+      attempt++;
+      print(
+          'DEBUG: Mencoba pendaftaran donatur (percobaan ke-$attempt dari $maxAttempts)');
 
-      // Arahkan ke halaman login
-      Get.offAllNamed(Routes.login);
-    } catch (e) {
-      print('Error registrasi donatur: $e');
+      try {
+        print('DEBUG: Validasi form berhasil, melanjutkan proses registrasi');
+        print('DEBUG: Email: ${emailController.text}');
+        print('DEBUG: Nama: ${namaController.text}');
+        print('DEBUG: Alamat: ${alamatController.text}');
+        print('DEBUG: No HP: ${noHpController.text}');
+        print(
+            'DEBUG: Jenis: ${jenisController.text.isEmpty ? 'Individu' : jenisController.text}');
 
-      String errorMessage = 'Gagal melakukan registrasi';
+        // Proses registrasi donatur
+        await _authProvider.signUpDonatur(
+          email: emailController.text,
+          password: passwordController.text,
+          namaLengkap: namaController.text,
+          alamat: alamatController.text,
+          noHp: noHpController.text,
+          jenis:
+              jenisController.text.isEmpty ? 'Individu' : jenisController.text,
+        );
 
-      // Tangani error sesuai jenisnya
-      if (e.toString().contains('email konfirmasi')) {
-        errorMessage =
-            'Gagal mengirim email konfirmasi. Mohon periksa alamat email Anda dan coba lagi nanti.';
-      } else if (e.toString().contains('Email sudah terdaftar')) {
-        errorMessage =
-            'Email sudah terdaftar. Silakan gunakan email lain atau login dengan email tersebut.';
-      } else if (e.toString().contains('weak-password')) {
-        errorMessage =
-            'Password terlalu lemah. Gunakan kombinasi huruf, angka, dan simbol.';
-      } else if (e.toString().contains('invalid-email')) {
-        errorMessage = 'Format email tidak valid.';
-      } else {
-        errorMessage = 'Gagal melakukan registrasi: ${e.toString()}';
+        print('DEBUG: Registrasi donatur berhasil');
+        success = true;
+
+        Get.snackbar(
+          'Sukses',
+          'Registrasi donatur berhasil! Silakan login dengan akun Anda.',
+          snackPosition: SnackPosition.TOP,
+          backgroundColor: Colors.green,
+          colorText: Colors.white,
+          duration: const Duration(seconds: 5),
+        );
+
+        // Bersihkan form
+        clearDonaturRegistrationForm();
+
+        // Arahkan ke halaman login
+        Get.offAllNamed(Routes.login);
+      } catch (e) {
+        lastError = e is Exception ? e : Exception(e.toString());
+        print('ERROR: Error registrasi donatur (percobaan ke-$attempt): $e');
+        print('ERROR Detail: ${e.runtimeType} - ${e.toString()}');
+
+        // Cek apakah bisa dicoba lagi atau tidak
+        bool canRetry = false;
+        if (e.toString().contains('Database error saving new user')) {
+          canRetry = true; // Error database bisa dicoba lagi
+          print('DEBUG: Error database, akan mencoba lagi');
+          // Delay sedikit sebelum mencoba lagi
+          await Future.delayed(const Duration(seconds: 1));
+        } else if (e.toString().contains('User already registered')) {
+          // Jangan coba lagi jika email sudah terdaftar
+          canRetry = false;
+        }
+
+        if (!canRetry || attempt >= maxAttempts) {
+          // Jika tidak bisa retry atau sudah maksimal, tampilkan error
+          String errorMessage = 'Gagal melakukan registrasi';
+
+          // Tangani error sesuai jenisnya
+          if (e.toString().contains('email konfirmasi')) {
+            errorMessage =
+                'Gagal mengirim email konfirmasi. Mohon periksa alamat email Anda dan coba lagi nanti.';
+          } else if (e.toString().contains('Email sudah terdaftar')) {
+            errorMessage =
+                'Email sudah terdaftar. Silakan gunakan email lain atau login dengan email tersebut.';
+          } else if (e.toString().contains('weak-password')) {
+            errorMessage =
+                'Password terlalu lemah. Gunakan kombinasi huruf, angka, dan simbol.';
+          } else if (e.toString().contains('invalid-email')) {
+            errorMessage = 'Format email tidak valid.';
+          } else if (e.toString().contains('Database error')) {
+            errorMessage =
+                'Terjadi kesalahan pada database. Silakan coba lagi nanti atau hubungi administrator.';
+          } else {
+            errorMessage = 'Gagal melakukan registrasi: ${e.toString()}';
+          }
+
+          Get.snackbar(
+            'Error',
+            errorMessage,
+            snackPosition: SnackPosition.TOP,
+            backgroundColor: Colors.red,
+            colorText: Colors.white,
+            duration: const Duration(seconds: 7),
+          );
+          break; // Keluar dari loop
+        }
       }
+    }
 
-      Get.snackbar(
-        'Error',
-        errorMessage,
-        snackPosition: SnackPosition.TOP,
-        backgroundColor: Colors.red,
-        colorText: Colors.white,
-        duration: const Duration(seconds: 5),
-      );
-    } finally {
-      isLoading.value = false;
+    isLoading.value = false;
+
+    // Jika gagal setelah mencoba beberapa kali
+    if (!success && lastError != null) {
+      print('ERROR: Pendaftaran gagal setelah $attempt percobaan');
+      // Error sudah ditampilkan di dalam loop
     }
   }
 
diff --git a/lib/app/modules/auth/views/register_donatur_view.dart b/lib/app/modules/auth/views/register_donatur_view.dart
index f3aee8e..21b9c2a 100644
--- a/lib/app/modules/auth/views/register_donatur_view.dart
+++ b/lib/app/modules/auth/views/register_donatur_view.dart
@@ -3,6 +3,7 @@ import 'package:get/get.dart';
 import 'package:flutter_spinkit/flutter_spinkit.dart';
 import 'package:penyaluran_app/app/modules/auth/controllers/auth_controller.dart';
 import 'package:penyaluran_app/app/routes/app_pages.dart';
+import 'package:penyaluran_app/app/theme/app_theme.dart';
 
 class RegisterDonaturView extends GetView<AuthController> {
   const RegisterDonaturView({super.key});
@@ -13,7 +14,7 @@ class RegisterDonaturView extends GetView<AuthController> {
       appBar: AppBar(
         title: const Text('Daftar Donatur'),
         centerTitle: true,
-        backgroundColor: Colors.blue,
+        backgroundColor: AppTheme.primaryColor,
         foregroundColor: Colors.white,
         elevation: 0,
         shape: const RoundedRectangleBorder(
